Request

Response

    Project Team Members
    POST

    project-team-members

    This operation is deprecated and will be removed in a future version. We do not recommend using it in production applications.

    Creates a new project team member.

    Note that the API user must be a project team member to add other users to the project team including projects owned by external companies.

    The API user can add themselves to a project team of a project that belongs to the user’s company.

    Resource Information

    Method and URI
    POST
    https://developer.api.autodesk.com/construction/buildingconnected/v2/project-team-members
    Authentication Context
    User context required
    Required OAuth Scopes
    data:write
    Data Format
    JSON

    Request

    Headers

    Authorization*
    string
    Must be Bearer <token>, where <token> is a three-legged access token obtained via an Authorization Code flow.
    Content-Type*
    string
    Must be application/json
    * Required

    Request

    Body Structure

    Expand all
    user*
    object
    User information to add to the project team. Either id or email is required. If both are provided, the API will result in error. Users external to the project’s company can be added.
    id
    string
    The unique BuildingConnected ID of the user to add to the project team.

    Max length: 24

    email
    string
    The email address of the user to add to the project team.
    projectId*
    string
    A project of which the user is a member, to which you want to add a team member..

    Max length: 24

    isProjectLead
    boolean
    Indicates whether the new team member is the project lead.

    Possible values:

    • true: The new team member is the project lead.
    • false: The new team member is not the project lead.

    Note that there can be only one project lead per project. When you set this value to true, BuildingConnected automatically sets all other project team members’ isProjectLead values to false.

    For Batch endpoint, only one isProjectLead can be true per projectId.

    If the member is from external company, they must view the project first before they can be set as project lead.

    If the member hasn’t claimed their account, they must do so before they can be set as project lead.

    privileges
    enum:string
    Indicates the team member’s permissions on the project if it is a template.

    Possible values:

    • ADMIN: (Default) The team member has administrator privileges on the specified project.
    • VIEW_ONLY: The team member has only read access to the project.

    This value must be null or unset if the project is not a template.

    notificationPreferences
    enum:string
    Notification preferences selected by the user for the specified project. Possible values:
    • ALL (Default): Receive notifications for all bid package activity on the project.
    • BID_PACKAGE_LEAD: Receive notifications only for bid packages where the user is the lead.
    • SELECTED_BID_PACKAGES: Receive notifications only for specific bid packages (defined by subscribedBidPackages).
    • MUTE: Receive no notifications.
    subscribedBidPackages
    array: string
    An array of the IDs of selected bid packages that the member will receive notifications from.

    Note that this value is relevant only if the value of notificationPreferences is set to SELECTED_BID_PACKAGES. If it is not, this value must be null.

    The member can subscribe to a maximum of 1000 bid packages.

    * Required

    Response

    HTTP Status Code Summary

    201
    Created
    Created
    400
    Bad Request
    The parameters of the requested operation are invalid.
    401
    Unauthorized
    The provided bearer token is not valid.
    403
    Forbidden
    The user or service represented by the bearer token does not have permission to perform this operation.
    404
    Not Found
    The requested resource could not be found.
    409
    Conflict
    The user is already a project team member on this project.
    429
    Too Many Requests
    Rate limit exceeded; wait some time before retrying. The ‘Retry-After’ header might provide the amount of the time to wait.
    500
    Internal Server Error
    An unknown error occurred on the server.

    Response

    Header (201)

    Location
    string
    The created resource’s location.

    Response

    Body Structure (201)

    Expand all
    id
    string
    The unique generated ID of a project team member. This is not equivalent to a user ID.

    Max length: 24

    user
    object
    Employment information for a given user on BuildingConnected.
    id
    string
    The unique BuildingConnected ID of this user.

    Max length: 24

    autodeskId
    string
    The user’s Autodesk ID. By default this value is null because an Autodesk ID is not a requirement to log in to BuildingConnected.

    Users can associate their BuildingConnected user login with an Autodesk ID by going to account settings in BuildingConnected.

    Default: null

    emailVerified
    boolean
    Indicates whether the user has verified the listed email address. Possible values:
    • true: The user’s email has been verified.
    • false: The user’s email has not been verified.
    employmentVerified
    boolean
    Indicates whether the user’s employment at the company has been verified. Possible values:
    • true: The user’s employment has been verified.
    • false: The user’s employment has not been verified.
    createdAt
    datetime: ISO 8601
    The date and time that the user was created, in the following format: YYYY-MM-DDThh:mm:ss.sz (ISO 8601 format).
    firstName
    string
    The user’s first name.
    lastName
    string
    The user’s last name.
    email
    string
    The user’s email address.
    alternateEmails
    array: string
    The user’s alternate email addresses.
    avatarImageUrl
    string
    The cached imgix url for the avatar image of the user with size denoted in last two values of rect parameter in the url.
    jobTitle
    string
    The user’s job title.
    phoneNumber
    string
    The user’s phone number.
    companyId
    string
    The unique BuildingConnected ID of the company to which this user belongs.

    Max length: 24

    isAccountClaimed
    boolean
    Indicates whether the user has claimed their BuildingConnected account. Possible values:
    • true: The user has claimed their BuildingConnected account.
    • false: The user has not claimed their BuildingConnected account.
    bidBoardPermissions
    object
    An object defining what permissions the user has in Bid Board.
    viewAll
    boolean
    Indicates whether this user can view opportunities of which they aren’t explicitly a member. Possible values:
    • true: The user can see all opportunities belonging to all offices that use Bid Board Pro.
    • false: The user can see only opportunities of which they are a member.
    reports
    boolean
    Indicates whether this user has access to the Reports tab on Bid Board. Possible values:
    • true: The user can access Reports.
    • false: The user cannot access Reports.
    leaderboard
    boolean
    Indicates whether this user has access to the Leaderboard tab on Bid Board. Possible values:
    • true: The user can access the Leadboard.
    • false: The user cannot access the Leadboard.
    modifyPermissions
    boolean
    Indicates whether the user can manipulate the Bid Board permissions of other users. Possible values:
    • true: The user can manipulate other users’ permissions.
    • false: The user cannnot manipulate permissions.
    offices
    array: object
    An array of objects describing the offices to which this user belongs.
    id
    string
    The unique ID of the office.

    Max length: 24

    isPrimary
    boolean
    Indicates whether this office is the primary office of the user. A user can have only one priamry office. Possible values:
    • true: This office is the user’s primary office.
    • false: This office is not the user’s primary office.
    hasBbPro
    boolean
    Indicates whether this office has an active Bid Board Pro subscription at the office level. This reflects the office’s subscription only and is independent of whether individual users have a Bid Board Pro license assigned directly to them. Possible values:
    • true: The office has a Bid Board Pro subscription.
    • false: The office does not have a Bid Board Pro subscription.
    hasBcPro
    boolean
    Indicates whether this office has an active BuildingConnected Pro subscription at the office level. This reflects the office’s subscription only and is independent of whether individual users have a BC Pro license assigned directly to them. Possible values:
    • true: The office has a BC Pro subscription.
    • false: The office does not have a BC Pro subscription.
    officeLead
    boolean
    Indicates whether this user is a lead for this office. Users can set themselves as leads at any time.
    • true: The user is a lead for this office.
    • false: The user is not a lead for this office.
    name
    string
    The name of this office.
    address
    string
    The full street address of this office.
    projectId
    string
    The project of which the user is a member.

    Max length: 24

    currentAccLinkedProjectId
    string
    The project ID of a Forma project to link to with this project.
    createdBy
    string
    User ID of whomever added this user to the project team.

    Max length: 24

    isProjectLead
    boolean
    Indicates whether the team member is the project lead.

    Possible values:

    • true: The new team member is the project lead.
    • false: The new team member is not the project lead.

    Note that there can be only one project lead per project. When you set this value to true, BuildingConnected automatically sets all other project team members’ isProjectLead values to false.

    privileges
    enum:string
    Indicates the team member’s permissions on the project if it is a template.

    Possible values:

    • ADMIN: (Default) The team member has administrator privileges on the specified project.
    • VIEW_ONLY: The team member has only read access to the project.

    This value must be null or unset if the project is not a template.

    createdAt
    datetime: ISO 8601
    The date and time that the user was added to the project, in ISO 8601 format.
    updatedAt
    datetime: ISO 8601
    The date and time of the last update to this document, in ISO 8601 format.
    firstViewedAt
    datetime: ISO 8601
    The date and time that the user first viewed the project in the BuildingConnected application, in ISO 8601 format.
    ndaSignedAt
    string
    The date and time that the user signed the NDA for the project, in ISO 8601 format. Default value is NULL.
    ndaSignedIpAddress
    string
    The IP address of the user when that user signed the NDA. Default value is null.
    notificationPreferences
    enum:string
    Notification preferences selected by the user for this project. Possible values:
    • ALL (Default): Receive notifications for all bid package activity on the project.
    • BID_PACKAGE_LEAD: Receive notifications only for bid packages where the user is the lead.
    • SELECTED_BID_PACKAGES: Receive notifications only for specific bid packages (defined by subscribedBidPackages).
    • MUTE: Receive no notifications.
    subscribedBidPackages
    array: string
    An array of the IDs of selected bid packages that the member will receive notifications from.

    Note that this value is relevant only if the value of notificationPreferences is set to SELECTED_BID_PACKAGES. If it is not, this value must be null.

    The member can subscribe to a maximum of 1000 bid packages.

    Example

    Created

    Request

    curl -v 'https://developer.api.autodesk.com/construction/buildingconnected/v2/project-team-members' \
      -X 'POST' \
      -H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a' \
      -H 'Content-Type: application/json' \
      -d '{
            "user": {
              "id": "5d8104b87e392d56e1e4b4ca",
              "email": "email@example.com"
            },
            "projectId": "5d8104b87e392d56e3d4b5ca",
            "isProjectLead": false,
            "privileges": "ADMIN",
            "notificationPreferences": "ALL",
            "subscribedBidPackages": [
              "5d8104b87e392d56e3f4b4ca"
            ]
          }'
    
    Show More

    Response

    {
      "id": "5d8104b87e392d56e1e4b4ca",
      "user": {
        "id": "5d8104b87e392d56e1e4b4ca",
        "autodeskId": null,
        "emailVerified": true,
        "employmentVerified": true,
        "createdAt": "2021-08-19T23:07:16.083Z",
        "firstName": "First",
        "lastName": "Last",
        "email": "email@example.com",
        "alternateEmails": [
          "email@alternate.com"
        ],
        "avatarImageUrl": "https://www.example.com/image.png?auto=format&rect=208,16,300,299",
        "jobTitle": "Estimator",
        "phoneNumber": "555-555-5555",
        "companyId": "5d8104b87e392d56e1e4c7df",
        "isAccountClaimed": true,
        "bidBoardPermissions": {
          "viewAll": true,
          "reports": false,
          "leaderboard": true,
          "modifyPermissions": false
        },
        "offices": [
          {
            "id": "5b7104b87e392d56e1e4b3bf",
            "isPrimary": true,
            "hasBbPro": true,
            "hasBcPro": false,
            "officeLead": false,
            "name": "San Francisco",
            "address": "600 California St., 6th Floor, San Francisco, CA 94108"
          }
        ]
      },
      "projectId": "5d8104b87e392d56e3d4b5ca",
      "currentAccLinkedProjectId": "00f1b796-293a-4c1e-9474-f09711011426",
      "createdBy": "5d8104b87e392d56e3d4b5cd",
      "isProjectLead": false,
      "privileges": "ADMIN",
      "createdAt": "2020-12-07T18:00:00.000Z",
      "updatedAt": "2021-01-10T13:00:00.000Z",
      "firstViewedAt": "2021-01-08T13:00:00.000Z",
      "ndaSignedAt": null,
      "ndaSignedIpAddress": null,
      "notificationPreferences": "ALL",
      "subscribedBidPackages": []
    }
    
    Show More